augroup terminal_job
  au!
  au TermOpen * startinsert
  au TermOpen * setlocal listchars= nonumber norelativenumber
augroup END

augroup ResizeWindowsProportionally
  au!
  autocmd VimResized * :wincmd =
augroup END

augroup ToggleSearchHighlighting
  autocmd!
  autocmd InsertEnter * setlocal nohlsearch
augroup END

augroup UserStatusline
  autocmd!
  autocmd BufEnter,WinEnter,TermOpen * setlocal statusline=%!ActiveStatus()
  autocmd WinLeave * setlocal statusline=%!PassiveStatus()
  autocmd ColorScheme * hi User1 guifg=DarkRed guibg=Black
  autocmd ColorScheme * hi User2 guifg=White guibg=Black
  autocmd ColorScheme * hi User3 guifg=Cyan guibg=Black
  autocmd ColorScheme * hi User4 guifg=Orange guibg=Black
  autocmd ColorScheme * hi User5 guifg=Red guibg=Black
  autocmd ColorScheme * hi User6 guifg=Gray guibg=Black
  autocmd ColorScheme * hi User7 guifg=Gray guibg=Black
  autocmd ColorScheme * hi User8 guifg=DarkYellow guibg=Black
augroup END

" Use completion-nvim in every buffer
autocmd BufEnter * lua require'completion'.on_attach()

augroup LuaHighlight
  autocmd!
  autocmd TextYankPost * silent! lua require'vim.highlight'.on_yank("IncSearch", 2000)
augroup END

augroup Scrollbar
  autocmd!
  autocmd BufEnter    * silent! lua require('scrollbar').show()
  autocmd BufLeave    * silent! lua require('scrollbar').clear()

  autocmd CursorMoved * silent! lua require('scrollbar').show()
  autocmd VimResized  * silent! lua require('scrollbar').show()

  autocmd FocusGained * silent! lua require('scrollbar').show()
  autocmd FocusLost   * silent! lua require('scrollbar').clear()
augroup END
