" Better whitespace
let g:better_whitespace_enabled = 1
let g:strip_whitespace_on_save = 1
let g:better_whitespace_operator = ''
let g:strip_whitespace_confirm = 0
" Automatically detect style file and apply style to formatting
let g:clang_format#detect_style_file = 1
" For workspace
let g:workspace_session_directory = $HOME . '/.vim/session/'
let g:workspace_undodir = $HOME . '/.vim/undodir'
let g:workspace_autosave = 0
let g:workspace_autosave_ignore = ['gitcommit', 'qf', 'tagbar']
let g:workspace_session_disable_on_args = 1
" Toggle quickfix/location list
let g:toggle_list_no_mappings = 1

let g:mapleader = "\<Space>"
let g:maplocalleader = ','
let g:which_key_use_floating_win = 1

" Rainbow Parentheses
let g:rainbow_active = 1

" FZF
let $FZF_DEFAULT_OPTS="--layout=reverse --bind \"Ctrl-n:preview-down,Ctrl-p:preview-up\""
let g:fzf_layout = { 'window': { 'width': 0.8, 'height': 0.8 } }

" Incremental search
let g:incsearch#auto_nohlsearch = 1

" Sneak
let g:sneak#label = 1
let g:sneak#s_next = 1
let g:sneak#use_ic_scs = 0

" vimtex
let g:tex_flavor = 'latex'
let g:vimtex_view_general_viewer = 'qpdfview'
let g:vimtex_view_general_options = '--unique @pdf\#src:@tex:@line:@col'
let g:vimtex_view_general_options_latexmk = '--unique'

" Floaterm
let g:floaterm_open_in_root  = 0
let g:floaterm_position      = 'center'
let g:floaterm_width         = 0.8
let g:floaterm_height        = 0.8
let g:floaterm_winblend      = 0
let g:floaterm_borderchars   = ['─', '│', '─', '│', '╭', '╮', '╯', '╰']

" Quickr Cscope
let g:quickr_cscope_keymaps = 0

" Neovim LSP Diagnostics
let g:diagnostic_enable_virtual_text = 0
let g:diagnostic_show_sign = 1
let g:diagnostic_auto_popup_while_jump = 1
let g:diagnostic_insert_delay = 1

" For nvim-completion
let g:completion_enable_auto_popup = 1
let g:completion_auto_change_source = 1
let g:completion_chain_complete_list = {
  \ 'c': [
  \    {'complete_items': ['buffers']},
  \    {'mode': 'keyn'},
  \    {'mode': 'tags'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'}
  \],
  \ 'haskell': [
  \    {'complete_items': ['lsp']},
  \    {'complete_items': ['buffers']},
  \    {'mode': 'keyn'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'},
  \],
  \ 'rust': [
  \    {'complete_items': ['lsp']},
  \    {'complete_items': ['buffers']},
  \    {'mode': 'keyn'}
  \],
  \ 'purescript': [
  \    {'complete_items': ['lsp']},
  \    {'complete_items': ['buffers']},
  \    {'mode': 'keyn'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'}
  \],
  \ 'default': [
  \    {'complete_items': ['buffers']},
  \    {'mode': 'keyn'},
  \    {'mode': '<c-p>'},
  \    {'mode': '<c-n>'},
  \],
  \}

lua require 'lsp'
lua require 'treesitter'
